# Vite Plugin OX Bundle

A vite plugin to create a custom bundle file to reduce js requests for App Suite UI

## Install

```sh
pnpm i "@open-xchange/vite-plugin-ox-bundle"
```

## How to use

```js
// in the vite.config.js
import vitePluginOxBundle from '@open-xchange/vite-plugin-ox-bundle'

return {
  plugins: [vitePluginOxBundle()]
}
```

You need to manual define a bundle file:

```js
// bundles.json
[
  {
    name: 'mybundle.js',
    files: [
      ....
    ]
  }
]
```

## Options

You can provide the following options to the plugin:

* src `<string>` Path to predefined bundles file. Default: `./bundles.json`
* ignore `<string[]>` Paths to be ignored. Default: `[]`
