import type { Plugin } from 'vite'
import type { GettextPluginModuleMeta } from '@open-xchange/rollup-plugin-po2json'

import type { OxManifest } from '../util.js'
import type { VitePluginOxManifests, VitePluginOxManifestsOptions } from '../index.js'

/**
 * Type shape of an internal manifests implementation plugin.
 */
export interface VitePluginOxManifestsPlugin extends Plugin {
  pluginResolved?(plugin: VitePluginOxManifests): void
  getManifests?(): OxManifest[] | Promise<OxManifest[]>
}

/**
 * Type shape of internal module metadata used by the manifests plugin.
 */
export interface VitePluginOxManifestsModuleMeta extends GettextPluginModuleMeta {
  manifests?: OxManifest[]
}

/**
 * Plugin generator function.
 */
export type VitePluginOxManifestsPluginFn = (options: Required<VitePluginOxManifestsOptions>) => VitePluginOxManifestsPlugin;

/**
 * Helper for type safety. Inspired by Vite's `defineConfig`.
 */
export function definePlugin (fn: VitePluginOxManifestsPluginFn): VitePluginOxManifestsPluginFn {
  return fn
}
